using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Call_WorkOrder
	/// </summary>
	public partial class T_Call_WorkOrder
    {
        public T_Call_WorkOrder()
        { }
        #region  Method



        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(CallCenterApi.Model.T_Call_WorkOrder model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Call_WorkOrder(");
            strSql.Append("F_WORKORDERID,CallId,F_WORKORDERSTATEID,TalkLongTime)");
            strSql.Append(" values (");
            strSql.Append("@F_WORKORDERID,@CallId,@F_WORKORDERSTATEID,@TalkLongTime)");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WORKORDERID", SqlDbType.Int,4),
                    new SqlParameter("@CallId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_WORKORDERSTATEID", SqlDbType.Int,4),
                    new SqlParameter("@TalkLongTime", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WORKORDERID;
            parameters[1].Value = model.CallId;
            parameters[2].Value = model.F_WORKORDERSTATEID;
            parameters[3].Value = model.TalkLongTime;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Call_WorkOrder model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Call_WorkOrder set ");
            strSql.Append("F_WORKORDERID=@F_WORKORDERID,");
            strSql.Append("CallId=@CallId,");
            strSql.Append("F_WORKORDERSTATEID=@F_WORKORDERSTATEID,");
            strSql.Append("TalkLongTime=@TalkLongTime");
            strSql.Append(" where ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WORKORDERID", SqlDbType.Int,4),
                    new SqlParameter("@CallId", SqlDbType.VarChar,50),
                    new SqlParameter("@F_WORKORDERSTATEID", SqlDbType.Int,4),
                    new SqlParameter("@TalkLongTime", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WORKORDERID;
            parameters[1].Value = model.CallId;
            parameters[2].Value = model.F_WORKORDERSTATEID;
            parameters[3].Value = model.TalkLongTime;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete()
        {
            //该表无主键信息，请自定义主键/条件字段
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_WorkOrder ");
            strSql.Append(" where ");
            SqlParameter[] parameters = {
};

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Call_WorkOrder GetModel()
        {
            //该表无主键信息，请自定义主键/条件字段
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_WORKORDERID,CallId,F_WORKORDERSTATEID,TalkLongTime from T_Call_WorkOrder ");
            strSql.Append(" where ");
            SqlParameter[] parameters = {
};

            CallCenterApi.Model.T_Call_WorkOrder model = new CallCenterApi.Model.T_Call_WorkOrder();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_WORKORDERID"] != null && ds.Tables[0].Rows[0]["F_WORKORDERID"].ToString() != "")
                {
                    model.F_WORKORDERID = int.Parse(ds.Tables[0].Rows[0]["F_WORKORDERID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["CallId"] != null && ds.Tables[0].Rows[0]["CallId"].ToString() != "")
                {
                    model.CallId = ds.Tables[0].Rows[0]["CallId"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_WORKORDERSTATEID"] != null && ds.Tables[0].Rows[0]["F_WORKORDERSTATEID"].ToString() != "")
                {
                    model.F_WORKORDERSTATEID = int.Parse(ds.Tables[0].Rows[0]["F_WORKORDERSTATEID"].ToString());
                }
                if (ds.Tables[0].Rows[0]["TalkLongTime"] != null && ds.Tables[0].Rows[0]["TalkLongTime"].ToString() != "")
                {
                    model.TalkLongTime = int.Parse(ds.Tables[0].Rows[0]["TalkLongTime"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_WORKORDERID,CallId,F_WORKORDERSTATEID,TalkLongTime  ");
            strSql.Append(" FROM T_Call_WorkOrder WITH(NOLOCK) ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_WORKORDERID,CallId,F_WORKORDERSTATEID,TalkLongTime ");
            strSql.Append(" FROM T_Call_WorkOrder ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Call_WorkOrder ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T. desc");
            }
            strSql.Append(")AS Row, T.*  from T_Call_WorkOrder T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Call_WorkOrder";
			parameters[1].Value = "";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  Method
    }
}
